<template>
  <VForm>
    <fieldset v-for="(item, i) in internalVal" :key="i" class="fieldset">
      <legend class="d-flex align-center">
        <VSelect
          :value="item.type"
          :items="items"
          label="Tipo"
          hide-details
          :height="32"
          @change="changeTypeForm(i, $event)"
        />
        <VChip :input-value="true" :style="[i > 0 && { minWidth: '80px' }]">
          <VBtn icon small @click="addItemForm">
            <VIcon>mdi-plus</VIcon>
          </VBtn>
          <VBtn
            v-if="i > 0"
            icon
            small
            @click="
              $delete(internalVal, i)
              $forceUpdate()
            "
          >
            <VIcon>mdi-minus</VIcon>
          </VBtn>
        </VChip>
      </legend>

      <VRow dense>
        <!-- main -->
        <template v-if="item.type === 'text'">
          <VCol cols="12">
            <fieldset class="fieldset">
              <legend>Orientação</legend>

              <VRadioGroup
                v-model="item.orientation"
                class="ma-0"
                row
                hide-details
              >
                <VRadio label="Sequencial" value="sequential" />
                <VRadio label="Aleatória" value="random" />
              </VRadioGroup>
            </fieldset>
          </VCol>
          <template v-for="(val, n) in item.itens">
            <VCol :key="`val-${n}`" cols="11">
              <VTextarea
                v-model="item.itens[n]"
                :label="`Texto ${n + 1}`"
                :rows="3"
                class="mt-2"
                outlined
                auto-grow
                hide-details
              />
            </VCol>
            <VCol
              :key="`action-${n}`"
              cols="1"
              class="d-flex flex-column align-center justify-center"
            >
              <VBtn
                icon
                small
                @click="
                  item.itens.push('')
                  $forceUpdate()
                "
              >
                <VIcon>mdi-plus</VIcon>
              </VBtn>
              <VBtn
                v-if="n > 0"
                icon
                small
                @click="
                  $delete(item.itens, n)
                  $forceUpdate()
                "
              >
                <VIcon>mdi-minus</VIcon>
              </VBtn>
            </VCol>
          </template>
        </template>
        <template v-if="item.type === 'quick_reply'">
          <VCol
            v-for="(val, n) in item.items"
            :key="`val-${n}`"
            cols="12"
            class="mt-2"
          >
            <VTextarea
              v-model="val.text"
              label="Texto"
              :rows="3"
              outlined
              auto-grow
              hide-details
            />

            <fieldset
              v-for="(btnVal, btn) in val.buttons"
              :key="`btn-${btn}`"
              class="fieldset mt-2"
            >
              <legend>
                <VChip :input-value="true">
                  <VBtn icon small @click="addButtonQuickReply(i, n)">
                    <VIcon>mdi-plus</VIcon>
                  </VBtn>
                  <VBtn
                    v-if="btn > 0"
                    icon
                    small
                    @click="
                      $delete(val.buttons, btn)
                      $forceUpdate()
                    "
                  >
                    <VIcon>mdi-minus</VIcon>
                  </VBtn>
                </VChip>
              </legend>

              <VRow>
                <VCol cols="12">
                  <VRadioGroup
                    v-model="btnVal.type"
                    class="ma-0"
                    row
                    hide-details
                  >
                    <VRadio label="Texto" value="postback" />
                    <VRadio label="URL" value="web_url" />
                  </VRadioGroup>
                </VCol>
                <VCol sm="6" cols="12">
                  <VTextField
                    v-model="btnVal.title"
                    label="Título"
                    counter="20"
                    outlined
                  />
                </VCol>
                <VCol sm="6" cols="12">
                  <VTextField
                    v-model="btnVal.payload"
                    label="Payload"
                    outlined
                    hide-details
                  />
                </VCol>
              </VRow>
            </fieldset>
          </VCol>
        </template>
        <template v-else>
          <VCol v-for="(val, n) in item.items" :key="`val-${n}`" cols="12">
            <fieldset class="fieldset">
              <legend>
                <VChip :input-value="true">
                  <VBtn icon small @click="addItemCard(i)">
                    <VIcon>mdi-plus</VIcon>
                  </VBtn>
                  <VBtn
                    v-if="n > 0"
                    icon
                    small
                    @click="
                      $delete(item.items, n)
                      $forceUpdate()
                    "
                  >
                    <VIcon>mdi-minus</VIcon>
                  </VBtn>
                </VChip>
              </legend>

              <VRow>
                <VCol md="4" sm="6" cols="12">
                  <VTextField
                    v-model="val.title"
                    label="Título"
                    outlined
                    hide-details
                  />
                </VCol>
                <VCol md="4" sm="6" cols="12">
                  <VTextField
                    v-model="val.subtitle"
                    label="Subtítulo"
                    outlined
                    hide-details
                  />
                </VCol>
                <VCol md="4" cols="12">
                  <VTextField
                    v-model="val.payload"
                    label="URL Imagem"
                    outlined
                    hide-details
                  >
                    <template v-slot:append>
                      <VDialog v-model="dialog" max-width="600">
                        <template v-slot:activator="{ on: menu, attrs }">
                          <VTooltip bottom>
                            <template v-slot:activator="{ on: tooltip }">
                              <VBtn
                                icon
                                v-bind="attrs"
                                style="margin-top: -7px;"
                                v-on="{ ...menu, ...tooltip }"
                              >
                                <VIcon>mdi-image</VIcon>
                              </VBtn>
                            </template>
                            <span>Visualizar Imagem</span>
                          </VTooltip>
                        </template>
                        <VCard>
                          <VImg v-if="val.payload" :src="val.payload" />
                          <VCardActions>
                            <VSpacer />
                            <VBtn icon @click="dialog = false">
                              <VIcon>mdi-close</VIcon>
                            </VBtn>
                          </VCardActions>
                        </VCard>
                      </VDialog>
                    </template>
                  </VTextField>
                </VCol>
                <VCol
                  v-for="(btnVal, btn) in val.buttons"
                  :key="`btn-${btn}`"
                  cols="12"
                >
                  <fieldset class="fieldset">
                    <legend>
                      <VChip :input-value="true">
                        <VBtn icon small @click="addButtonQuickReply(i, n)">
                          <VIcon>mdi-plus</VIcon>
                        </VBtn>
                        <VBtn
                          v-if="btn > 0"
                          icon
                          small
                          @click="
                            $delete(val.buttons, btn)
                            $forceUpdate()
                          "
                        >
                          <VIcon>mdi-minus</VIcon>
                        </VBtn>
                      </VChip>
                    </legend>

                    <VRow>
                      <VCol cols="12">
                        <VRadioGroup
                          v-model="btnVal.type"
                          class="ma-0"
                          row
                          hide-details
                        >
                          <VRadio label="Texto" value="postback" />
                          <VRadio label="URL" value="web_url" />
                        </VRadioGroup>
                      </VCol>
                      <VCol sm="6" cols="12">
                        <VTextField
                          v-model="btnVal.title"
                          label="Título"
                          counter="20"
                          outlined
                        />
                      </VCol>
                      <VCol sm="6" cols="12">
                        <VTextField
                          v-model="btnVal.payload"
                          label="Payload"
                          outlined
                          hide-details
                        />
                      </VCol>
                    </VRow>
                  </fieldset>
                </VCol>
              </VRow>
            </fieldset>
          </VCol>
        </template>
      </VRow>
    </fieldset>
  </VForm>
</template>

<script>
export default {
  props: {
    // v-model
    value: {
      type: Array,
      default: () => [],
    },
  },

  data: () => ({
    dialog: false,

    internalVal: [
      {
        type: 'text',
        orientation: 'sequential',
        itens: [''],
      },
    ],
    items: ['text', 'quick_reply', 'card'],
  }),

  computed: {
    valueModel: {
      get() {
        return this.value
      },
      set(val) {
        this.$emit('input', val)
      },
    },
  },

  watch: {
    internalVal: {
      immediate: true,
      deep: true,
      handler(newVal, oldVal) {
        if (typeof oldVal !== 'undefined') {
          this.valueModel = newVal
        }
      },
    },
  },

  mounted() {
    if (Object.keys(this.value).length > 0) {
      this.internalVal = this.value
    } else {
      this.valueModel = this.internalVal
    }
  },

  methods: {
    addItemForm() {
      this.internalVal.push({
        type: 'text',
        orientation: 'sequential',
        itens: [''],
      })
      this.$forceUpdate()
    },

    addButtonQuickReply(i, n) {
      this.internalVal[i].items[n].buttons.push({
        title: '',
        payload: '',
        type: 'postback',
      })
      this.$forceUpdate()
    },

    addItemCard(i) {
      this.internalVal[i].items.push({
        title: '',
        subtitle: '',
        image_url: '',
        buttons: [{ title: '', payload: '', type: 'postback' }],
      })
      this.$forceUpdate()
    },

    changeTypeForm(i, val) {
      switch (val) {
        case 'text':
          this.internalVal[i] = {
            type: 'text',
            orientation: 'sequential',
            itens: [''],
          }
          break
        case 'quick_reply':
          this.internalVal[i] = {
            type: val,
            items: [
              {
                text: '',
                buttons: [{ title: '', payload: '', type: 'postback' }],
              },
            ],
          }
          break
        default:
          this.internalVal[i] = {
            type: val,
            items: [
              {
                title: '',
                subtitle: '',
                image_url: '',
                buttons: [{ title: '', payload: '', type: 'postback' }],
              },
            ],
          }
          break
      }

      this.$forceUpdate()
    },
  },
}
</script>
